// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/PingCAP-QE/ee-apps/cloudevents-server/ent/predicate"
	"github.com/PingCAP-QE/ee-apps/cloudevents-server/ent/problemcaserun"
)

// ProblemCaseRunQuery is the builder for querying ProblemCaseRun entities.
type ProblemCaseRunQuery struct {
	config
	ctx        *QueryContext
	order      []problemcaserun.OrderOption
	inters     []Interceptor
	predicates []predicate.ProblemCaseRun
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the ProblemCaseRunQuery builder.
func (pcrq *ProblemCaseRunQuery) Where(ps ...predicate.ProblemCaseRun) *ProblemCaseRunQuery {
	pcrq.predicates = append(pcrq.predicates, ps...)
	return pcrq
}

// Limit the number of records to be returned by this query.
func (pcrq *ProblemCaseRunQuery) Limit(limit int) *ProblemCaseRunQuery {
	pcrq.ctx.Limit = &limit
	return pcrq
}

// Offset to start from.
func (pcrq *ProblemCaseRunQuery) Offset(offset int) *ProblemCaseRunQuery {
	pcrq.ctx.Offset = &offset
	return pcrq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (pcrq *ProblemCaseRunQuery) Unique(unique bool) *ProblemCaseRunQuery {
	pcrq.ctx.Unique = &unique
	return pcrq
}

// Order specifies how the records should be ordered.
func (pcrq *ProblemCaseRunQuery) Order(o ...problemcaserun.OrderOption) *ProblemCaseRunQuery {
	pcrq.order = append(pcrq.order, o...)
	return pcrq
}

// First returns the first ProblemCaseRun entity from the query.
// Returns a *NotFoundError when no ProblemCaseRun was found.
func (pcrq *ProblemCaseRunQuery) First(ctx context.Context) (*ProblemCaseRun, error) {
	nodes, err := pcrq.Limit(1).All(setContextOp(ctx, pcrq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{problemcaserun.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (pcrq *ProblemCaseRunQuery) FirstX(ctx context.Context) *ProblemCaseRun {
	node, err := pcrq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first ProblemCaseRun ID from the query.
// Returns a *NotFoundError when no ProblemCaseRun ID was found.
func (pcrq *ProblemCaseRunQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = pcrq.Limit(1).IDs(setContextOp(ctx, pcrq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{problemcaserun.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (pcrq *ProblemCaseRunQuery) FirstIDX(ctx context.Context) int {
	id, err := pcrq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single ProblemCaseRun entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one ProblemCaseRun entity is found.
// Returns a *NotFoundError when no ProblemCaseRun entities are found.
func (pcrq *ProblemCaseRunQuery) Only(ctx context.Context) (*ProblemCaseRun, error) {
	nodes, err := pcrq.Limit(2).All(setContextOp(ctx, pcrq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{problemcaserun.Label}
	default:
		return nil, &NotSingularError{problemcaserun.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (pcrq *ProblemCaseRunQuery) OnlyX(ctx context.Context) *ProblemCaseRun {
	node, err := pcrq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only ProblemCaseRun ID in the query.
// Returns a *NotSingularError when more than one ProblemCaseRun ID is found.
// Returns a *NotFoundError when no entities are found.
func (pcrq *ProblemCaseRunQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = pcrq.Limit(2).IDs(setContextOp(ctx, pcrq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{problemcaserun.Label}
	default:
		err = &NotSingularError{problemcaserun.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (pcrq *ProblemCaseRunQuery) OnlyIDX(ctx context.Context) int {
	id, err := pcrq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of ProblemCaseRuns.
func (pcrq *ProblemCaseRunQuery) All(ctx context.Context) ([]*ProblemCaseRun, error) {
	ctx = setContextOp(ctx, pcrq.ctx, "All")
	if err := pcrq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*ProblemCaseRun, *ProblemCaseRunQuery]()
	return withInterceptors[[]*ProblemCaseRun](ctx, pcrq, qr, pcrq.inters)
}

// AllX is like All, but panics if an error occurs.
func (pcrq *ProblemCaseRunQuery) AllX(ctx context.Context) []*ProblemCaseRun {
	nodes, err := pcrq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of ProblemCaseRun IDs.
func (pcrq *ProblemCaseRunQuery) IDs(ctx context.Context) (ids []int, err error) {
	if pcrq.ctx.Unique == nil && pcrq.path != nil {
		pcrq.Unique(true)
	}
	ctx = setContextOp(ctx, pcrq.ctx, "IDs")
	if err = pcrq.Select(problemcaserun.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (pcrq *ProblemCaseRunQuery) IDsX(ctx context.Context) []int {
	ids, err := pcrq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (pcrq *ProblemCaseRunQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, pcrq.ctx, "Count")
	if err := pcrq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, pcrq, querierCount[*ProblemCaseRunQuery](), pcrq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (pcrq *ProblemCaseRunQuery) CountX(ctx context.Context) int {
	count, err := pcrq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (pcrq *ProblemCaseRunQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, pcrq.ctx, "Exist")
	switch _, err := pcrq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (pcrq *ProblemCaseRunQuery) ExistX(ctx context.Context) bool {
	exist, err := pcrq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the ProblemCaseRunQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (pcrq *ProblemCaseRunQuery) Clone() *ProblemCaseRunQuery {
	if pcrq == nil {
		return nil
	}
	return &ProblemCaseRunQuery{
		config:     pcrq.config,
		ctx:        pcrq.ctx.Clone(),
		order:      append([]problemcaserun.OrderOption{}, pcrq.order...),
		inters:     append([]Interceptor{}, pcrq.inters...),
		predicates: append([]predicate.ProblemCaseRun{}, pcrq.predicates...),
		// clone intermediate query.
		sql:  pcrq.sql.Clone(),
		path: pcrq.path,
	}
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Repo string `json:"repo,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.ProblemCaseRun.Query().
//		GroupBy(problemcaserun.FieldRepo).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (pcrq *ProblemCaseRunQuery) GroupBy(field string, fields ...string) *ProblemCaseRunGroupBy {
	pcrq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &ProblemCaseRunGroupBy{build: pcrq}
	grbuild.flds = &pcrq.ctx.Fields
	grbuild.label = problemcaserun.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Repo string `json:"repo,omitempty"`
//	}
//
//	client.ProblemCaseRun.Query().
//		Select(problemcaserun.FieldRepo).
//		Scan(ctx, &v)
func (pcrq *ProblemCaseRunQuery) Select(fields ...string) *ProblemCaseRunSelect {
	pcrq.ctx.Fields = append(pcrq.ctx.Fields, fields...)
	sbuild := &ProblemCaseRunSelect{ProblemCaseRunQuery: pcrq}
	sbuild.label = problemcaserun.Label
	sbuild.flds, sbuild.scan = &pcrq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a ProblemCaseRunSelect configured with the given aggregations.
func (pcrq *ProblemCaseRunQuery) Aggregate(fns ...AggregateFunc) *ProblemCaseRunSelect {
	return pcrq.Select().Aggregate(fns...)
}

func (pcrq *ProblemCaseRunQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range pcrq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, pcrq); err != nil {
				return err
			}
		}
	}
	for _, f := range pcrq.ctx.Fields {
		if !problemcaserun.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if pcrq.path != nil {
		prev, err := pcrq.path(ctx)
		if err != nil {
			return err
		}
		pcrq.sql = prev
	}
	return nil
}

func (pcrq *ProblemCaseRunQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*ProblemCaseRun, error) {
	var (
		nodes = []*ProblemCaseRun{}
		_spec = pcrq.querySpec()
	)
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*ProblemCaseRun).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &ProblemCaseRun{config: pcrq.config}
		nodes = append(nodes, node)
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, pcrq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	return nodes, nil
}

func (pcrq *ProblemCaseRunQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := pcrq.querySpec()
	_spec.Node.Columns = pcrq.ctx.Fields
	if len(pcrq.ctx.Fields) > 0 {
		_spec.Unique = pcrq.ctx.Unique != nil && *pcrq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, pcrq.driver, _spec)
}

func (pcrq *ProblemCaseRunQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(problemcaserun.Table, problemcaserun.Columns, sqlgraph.NewFieldSpec(problemcaserun.FieldID, field.TypeInt))
	_spec.From = pcrq.sql
	if unique := pcrq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if pcrq.path != nil {
		_spec.Unique = true
	}
	if fields := pcrq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, problemcaserun.FieldID)
		for i := range fields {
			if fields[i] != problemcaserun.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := pcrq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := pcrq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := pcrq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := pcrq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (pcrq *ProblemCaseRunQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(pcrq.driver.Dialect())
	t1 := builder.Table(problemcaserun.Table)
	columns := pcrq.ctx.Fields
	if len(columns) == 0 {
		columns = problemcaserun.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if pcrq.sql != nil {
		selector = pcrq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if pcrq.ctx.Unique != nil && *pcrq.ctx.Unique {
		selector.Distinct()
	}
	for _, p := range pcrq.predicates {
		p(selector)
	}
	for _, p := range pcrq.order {
		p(selector)
	}
	if offset := pcrq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := pcrq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// ProblemCaseRunGroupBy is the group-by builder for ProblemCaseRun entities.
type ProblemCaseRunGroupBy struct {
	selector
	build *ProblemCaseRunQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (pcrgb *ProblemCaseRunGroupBy) Aggregate(fns ...AggregateFunc) *ProblemCaseRunGroupBy {
	pcrgb.fns = append(pcrgb.fns, fns...)
	return pcrgb
}

// Scan applies the selector query and scans the result into the given value.
func (pcrgb *ProblemCaseRunGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, pcrgb.build.ctx, "GroupBy")
	if err := pcrgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*ProblemCaseRunQuery, *ProblemCaseRunGroupBy](ctx, pcrgb.build, pcrgb, pcrgb.build.inters, v)
}

func (pcrgb *ProblemCaseRunGroupBy) sqlScan(ctx context.Context, root *ProblemCaseRunQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(pcrgb.fns))
	for _, fn := range pcrgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*pcrgb.flds)+len(pcrgb.fns))
		for _, f := range *pcrgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*pcrgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := pcrgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// ProblemCaseRunSelect is the builder for selecting fields of ProblemCaseRun entities.
type ProblemCaseRunSelect struct {
	*ProblemCaseRunQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (pcrs *ProblemCaseRunSelect) Aggregate(fns ...AggregateFunc) *ProblemCaseRunSelect {
	pcrs.fns = append(pcrs.fns, fns...)
	return pcrs
}

// Scan applies the selector query and scans the result into the given value.
func (pcrs *ProblemCaseRunSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, pcrs.ctx, "Select")
	if err := pcrs.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*ProblemCaseRunQuery, *ProblemCaseRunSelect](ctx, pcrs.ProblemCaseRunQuery, pcrs, pcrs.inters, v)
}

func (pcrs *ProblemCaseRunSelect) sqlScan(ctx context.Context, root *ProblemCaseRunQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(pcrs.fns))
	for _, fn := range pcrs.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*pcrs.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := pcrs.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
